<?

# COPYRIGHT:
#  
# This software is Copyright (c) 2007 NETWAYS GmbH, Christian Doebler 
#                                <support@netways.de>
# 
# (Except where explicitly superseded by other copyright notices)
# 
# 
# LICENSE:
# 
# This work is made available to you under the terms of Version 2 of
# the GNU General Public License. A copy of that license should have
# been provided with this software, but in any event can be snarfed
# from http://www.fsf.org.
# 
# This work is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301 or visit their web page on the internet at
# http://www.fsf.org.
# 
# 
# CONTRIBUTION SUBMISSION POLICY:
# 
# (The following paragraph is not intended to limit the rights granted
# to you to modify and distribute this software under the terms of
# the GNU General Public License and is only of importance to you if
# you choose to contribute your changes and enhancements to the
# community by submitting them to NETWAYS GmbH.)
# 
# By intentionally submitting any modifications, corrections or
# derivatives to this work, or any other work intended for use with
# this Software, to NETWAYS GmbH, you confirm that
# you are the copyright holder for those contributions and you grant
# NETWAYS GmbH a nonexclusive, worldwide, irrevocable,
# royalty-free, perpetual, license to use, copy, create derivative
# works based on those contributions, and sublicense and distribute
# those contributions and any derivatives thereof.
#
# Nagios and the Nagios logo are registered trademarks of Ethan Galstad.

/**
 * getContent - main function for this module
 *
 * @param		none
 * @return		HTML content
 */
function getContent () {

	global $p, $contactgroups, $message;

	// security
	if ($contactgroups['admin_only'] && !isAdmin()) return null;

	// get contactgroup to edit
	$contactgroup = ((isset($p['contactgroup'])) ? $p['contactgroup'] : null);
	if (empty($contactgroup)) $contactgroup = null;

	$templateContent = new nwTemplate(TEMPLATE_CONTACTGROUP_MANAGER);


	// assign statics
	$templateContent->assign('CONTACTGROUPS_OVERVIEW_LINK', CONTACTGROUPS_OVERVIEW_LINK);
	$templateContent->assign('CONTACTGROUPS_HEADING', CONTACTGROUPS_HEADING);
	$templateContent->assign('CONTACTGROUPS_HEADING_EDIT', CONTACTGROUPS_HEADING_EDIT);
	$templateContent->assign('CONTACTGROUPS_HEADING_ADD', CONTACTGROUPS_HEADING_ADD);
	$templateContent->assign('CONTACTGROUPS_ADD_NAME_SHORT', CONTACTGROUPS_ADD_NAME_SHORT);
	$templateContent->assign('CONTACTGROUPS_ADD_NAME', CONTACTGROUPS_ADD_NAME);
	$templateContent->assign('CONTACTGROUPS_ADD_BUTTON', CONTACTGROUPS_ADD_BUTTON);
	$templateContent->assign('CONTACTGROUPS_HEADING_SELECT', CONTACTGROUPS_HEADING_SELECT);
	$templateContent->assign('CONTACTGROUPS_EDIT_GROUPS', CONTACTGROUPS_EDIT_GROUPS);
	$templateContent->assign('CONTACTGROUPS_EDIT_BUTTON', CONTACTGROUPS_EDIT_BUTTON);
	$templateContent->assign('CONTACTGROUPS_DELETE_BUTTON', CONTACTGROUPS_DELETE_BUTTON);
	$templateContent->assign('CONTACTGROUP_CONFIRM_DEL', CONTACTGROUP_CONFIRM_DEL);
	// $templateContent->assign('', );


	// add message
	if (!empty($message)) $templateContent->assign('MESSAGE', $message);


	// assign contactgroup id
	$id = $contactgroup;
	if (empty($id)) {
		if (isset($p['id'])) {
			if (!empty($p['id'])) $id = $p['id'];
		} 
	}
	$templateContent->assign('ID', $id);


	// assign select fields for contactgroups and contacts
	$contactgroups = getContactGroups();
	$templateContent->assign('CONTACTGROUPS_EDIT_GROUPS_SELECT', htmlSelect('contactgroup', $contactgroups, $id));


	// add members content
	if (!empty($contactgroup)) {
		$templateSubContent = new nwTemplate(TEMPLATE_CONTACTGROUP_MANAGER_EDIT);
		$templateSubContent->assign('CONTACTGROUPS_HEADING_EDIT', CONTACTGROUPS_HEADING_EDIT);
		$templateSubContent->assign('CONTACTGROUPS_EDIT_NAME_SHORT', CONTACTGROUPS_EDIT_NAME_SHORT);
		$templateSubContent->assign('CONTACTGROUPS_EDIT_NAME', CONTACTGROUPS_EDIT_NAME);
		$templateSubContent->assign('CONTACTGROUPS_EDIT_USERS', CONTACTGROUPS_EDIT_USERS);
		$templateSubContent->assign('CONTACTGROUPS_SUBMIT_CHANGES_BUTTON', CONTACTGROUPS_SUBMIT_CHANGES_BUTTON);
		$templateSubContent->assign('CONTACTGROUP_NAME_SHORT', getContactGroupShortById($id));
		$templateSubContent->assign('CONTACTGROUP_NAME', $contactgroups[$id]);
		$templateSubContent->assign('CONTACTGROUPS_EDIT_USERS_SELECT', htmlSelect('contacts[]', getContacts(), getContactGroupMembers($contactgroup), 'size="5" multiple="multiple"'));
		$templateContent->assign('MEMBERS_CONTENT', $templateSubContent->getHTML());
	}


	return $templateContent->getHTML();

}


?>